diff --git a/web/pgadmin/browser/__init__.py b/web/pgadmin/browser/__init__.py
index 3741d9d3..fb1eb7db 100644
--- a/web/pgadmin/browser/__init__.py
+++ b/web/pgadmin/browser/__init__.py
@@ -680,17 +680,6 @@ def browser_css():
     """Render and return CSS snippets from the nodes and modules."""
     snippets = []
 
-    # Get configurable options
-    prefs = Preferences.module('sqleditor')
-
-    sql_font_size_pref = prefs.preference('sql_font_size')
-    sql_font_size = round(float(sql_font_size_pref.get()), 2)
-
-    if sql_font_size != 0:
-        snippets.append(
-            '.CodeMirror { font-size: %sem; }' % str(sql_font_size)
-        )
-
     for submodule in blueprint.submodules:
         snippets.extend(submodule.csssnippets)
     return make_response(
diff --git a/web/pgadmin/browser/static/js/browser.js b/web/pgadmin/browser/static/js/browser.js
index b26738cf..c330a871 100644
--- a/web/pgadmin/browser/static/js/browser.js
+++ b/web/pgadmin/browser/static/js/browser.js
@@ -2,8 +2,8 @@ define('pgadmin.browser', [
   'sources/tree/tree',
   'sources/gettext', 'sources/url_for', 'require', 'jquery', 'underscore', 'underscore.string',
   'bootstrap', 'sources/pgadmin', 'pgadmin.alertifyjs', 'bundled_codemirror',
-  'sources/check_node_visibility', 'sources/modify_animation', 'pgadmin.browser.utils', 'wcdocker',
-  'jquery.contextmenu', 'jquery.aciplugin', 'jquery.acitree',
+  'sources/check_node_visibility', 'pgadmin.browser.utils', 'wcdocker',
+  'jquery.contextmenu', 'jquery.aciplugin', 'jquery.acitree', 'pgadmin.browser.preferences',
   'pgadmin.browser.messages',
   'pgadmin.browser.menu', 'pgadmin.browser.panel',
   'pgadmin.browser.error', 'pgadmin.browser.frame',
@@ -13,7 +13,7 @@ define('pgadmin.browser', [
 ], function(
   tree,
   gettext, url_for, require, $, _, S, Bootstrap, pgAdmin, Alertify,
-  codemirror, checkNodeVisibility, modifyAnimation
+  codemirror, checkNodeVisibility
 ) {
   window.jQuery = window.$ = $;
   // Some scripts do export their object in the window only.
@@ -342,7 +342,7 @@ define('pgadmin.browser', [
 
       // Cache preferences
       obj.cache_preferences();
-      this.add_panels();
+      obj.add_panels();
       // Initialize the Docker
       obj.docker = new wcDocker(
         '#dockerContainer', {
@@ -400,11 +400,22 @@ define('pgadmin.browser', [
           mode: 'text/x-pgsql',
           readOnly: true,
           extraKeys: pgAdmin.Browser.editor_shortcut_keys,
-          tabSize: pgAdmin.Browser.editor_options.tabSize,
-          lineWrapping: pgAdmin.Browser.editor_options.wrapCode,
-          autoCloseBrackets: pgAdmin.Browser.editor_options.insert_pair_brackets,
-          matchBrackets: pgAdmin.Browser.editor_options.brace_matching,
         });
+      /* Cache may take time to load for the first time
+       * Reflect the changes once cache is available
+       */
+      let cacheIntervalId = setInterval(()=> {
+        let sqlEditPreferences = obj.get_preferences_for_module('sqleditor');
+        if(sqlEditPreferences) {
+          clearInterval(cacheIntervalId);
+          obj.reflectPreferences('sqleditor');
+        }
+      }, 500);
+
+      /* Check for sql editor preference changes */
+      obj.onPreferencesChange('sqleditor', function() {
+        obj.reflectPreferences('sqleditor');
+      });
 
       setTimeout(function() {
         obj.editor.setValue('-- ' + select_object_msg);
@@ -514,10 +525,6 @@ define('pgadmin.browser', [
       };
     },
 
-    // This will hold preference data (Works as a cache object)
-    // Here node will be a key and it's preference data will be value
-    preferences_cache: {},
-
     // Add menus of module/extension at appropriate menu
     add_menus: function(menus) {
       var self = this,
@@ -661,46 +668,6 @@ define('pgadmin.browser', [
         }
       }
     },
-
-    // Get preference value from cache
-    get_preference: function(module, preference) {
-      var self = this;
-      // If cache is not yet loaded then keep checking
-      if(_.size(self.preferences_cache) == 0) {
-        var check_preference = function() {
-            if(_.size(self.preferences_cache) > 0) {
-              clearInterval(preferenceTimeout);
-              return _.findWhere(
-              self.preferences_cache, {'module': module, 'name': preference}
-            );
-            }
-          },
-          preferenceTimeout = setInterval(check_preference, 1000);
-      }
-      else {
-        return _.findWhere(
-          self.preferences_cache, {'module': module, 'name': preference}
-        );
-      }
-    },
-
-    // Get and cache the preferences
-    cache_preferences: function () {
-      var self = this;
-      $.ajax({
-        url: url_for('preferences.get_all'),
-        success: function(res) {
-          self.preferences_cache = res;
-          pgBrowser.keyboardNavigation.init();
-          modifyAnimation.modifyAcitreeAnimation(self);
-          modifyAnimation.modifyAlertifyAnimation(self);
-        },
-        error: function(xhr, status, error) {
-          Alertify.pgRespErrorNotify(xhr, error);
-        },
-      });
-    },
-
     _findTreeChildNode: function(_i, _d, _o) {
       var loaded = _o.t.wasLoad(_i),
         onLoad = function() {
diff --git a/web/pgadmin/browser/static/js/preferences.js b/web/pgadmin/browser/static/js/preferences.js
new file mode 100644
index 00000000..73caa10d
--- /dev/null
+++ b/web/pgadmin/browser/static/js/preferences.js
@@ -0,0 +1,126 @@
+import pgAdmin from 'sources/pgadmin';
+import url_for from 'sources/url_for';
+import * as modifyAnimation from 'sources/modify_animation';
+import $ from 'jquery';
+import * as Alertify from 'pgadmin.alertifyjs';
+import * as SqlEditorUtils from 'sources/sqleditor_utils';
+
+const pgBrowser = pgAdmin.Browser = pgAdmin.Browser || {};
+
+/* Add cache related methods and properties */
+_.extend(pgBrowser, {
+  /* This will hold preference data (Works as a cache object)
+   * Here node will be a key and it's preference data will be value
+   */
+  preferences_cache: [],
+
+  /* This will be used by poller of new tabs/windows to check
+   * if preference cache is updated in parent/window.opener.
+   */
+  prefcache_version: 0,
+
+  /* Get cached preference */
+  get_preference: function(module, preference){
+    const self = this;
+    // If cache is not yet loaded then keep checking
+    if(_.size(self.preferences_cache) == 0) {
+      var check_preference = function() {
+          if(self.preferences_cache.length > 0) {
+            clearInterval(preferenceTimeout);
+            return _.findWhere(
+            self.preferences_cache, {'module': module, 'name': preference}
+          );
+          }
+        },
+        preferenceTimeout = setInterval(check_preference, 1000);
+    }
+    else {
+      return _.findWhere(
+        self.preferences_cache, {'module': module, 'name': preference}
+      );
+    }
+  },
+
+  /* Get all the preferences of a module */
+  get_preferences_for_module: function(module) {
+    var self = this;
+    let preferences = {};
+    _.each(
+      _.where(self.preferences_cache, {'module': module}),
+      (preference) => {
+        preferences[preference.name] = preference.value;
+      }
+    );
+    return preferences;
+  },
+
+  /* Get preference of an id, id is numeric */
+  get_preference_for_id : function(id) {
+    var self = this;
+    return _.findWhere(self.preferences_cache, {'id': id});
+  },
+
+  // Get and cache the preferences
+  cache_preferences: function (modulesChanged) {
+    var self = this;
+    return $.ajax({
+      url: url_for('preferences.get_all'),
+      success: function(res) {
+        self.preferences_cache = res;
+        self.prefcache_version = (new Date()).getTime();
+
+        pgBrowser.keyboardNavigation.init();
+        if(pgBrowser.tree) {
+          modifyAnimation.modifyAcitreeAnimation(self);
+          modifyAnimation.modifyAlertifyAnimation(self);
+        }
+
+        /* Once the cache is loaded after changing the preferences,
+         * notify the modules of the change
+         */
+        if(modulesChanged) {
+          _.each(modulesChanged, (val, key)=> {
+            $.event.trigger('prefchange:'+key);
+          });
+        }
+      },
+      error: function(xhr, status, error) {
+        Alertify.pgRespErrorNotify(xhr, error);
+      },
+    });
+  },
+
+  reflectPreferences: function(module) {
+    let obj = this;
+
+    if(module === 'sqleditor' || module === null || typeof module === 'undefined') {
+      let sqlEditPreferences = obj.get_preferences_for_module('sqleditor');
+
+      $(obj.editor.getWrapperElement()).css(
+        'font-size',SqlEditorUtils.calcFontSize(sqlEditPreferences.sql_font_size)
+      );
+      obj.editor.setOption('tabSize', sqlEditPreferences.tab_size);
+      obj.editor.setOption('lineWrapping', sqlEditPreferences.wrap_code);
+      obj.editor.setOption('autoCloseBrackets', sqlEditPreferences.insert_pair_brackets);
+      obj.editor.setOption('matchBrackets', sqlEditPreferences.brace_matching);
+      obj.editor.refresh();
+    }
+  },
+
+  onPreferencesChange: function(module, eventHandler) {
+    window.parent.$(parent.document).on('prefchange:'+module, function(event) {
+      /* If a sqleditor is closed, event handler will be called
+       * but the window.top will be null. Unbind the event handler
+       */
+      if(window.top === null) {
+        window.$(document).off(event);
+      }
+      else {
+        eventHandler(event);
+      }
+    });
+  },
+
+});
+
+export {pgBrowser};
diff --git a/web/pgadmin/preferences/static/js/preferences.js b/web/pgadmin/preferences/static/js/preferences.js
index cdbda0cd..7f21f80c 100644
--- a/web/pgadmin/preferences/static/js/preferences.js
+++ b/web/pgadmin/preferences/static/js/preferences.js
@@ -439,8 +439,20 @@ define('pgadmin.preferences', [
 
             if (e.button.text == gettext('OK')) {
               preferences.updateAll();
+
+              /* Find the modules changed */
+              let modulesChanged = {};
+              _.each(changed, (val, key)=> {
+                let pref = pgBrowser.get_preference_for_id(Number(key));
+                if(!modulesChanged[pref.module]) {
+                  modulesChanged[pref.module] = true;
+                }
+              });
+
               // Refresh preferences cache
-              setTimeout(pgBrowser.cache_preferences(), 2000);
+              setTimeout(()=> {
+                pgBrowser.cache_preferences(modulesChanged);
+              }, 500);
             }
           },
           build: function() {
diff --git a/web/pgadmin/static/js/backform.pgadmin.js b/web/pgadmin/static/js/backform.pgadmin.js
index c7b98496..7096ee7b 100644
--- a/web/pgadmin/static/js/backform.pgadmin.js
+++ b/web/pgadmin/static/js/backform.pgadmin.js
@@ -1,10 +1,11 @@
 define([
   'sources/gettext', 'underscore', 'underscore.string', 'jquery',
-  'backbone', 'backform', 'backgrid', 'codemirror', 'spectrum',
-  'pgadmin.backgrid', 'select2',
-], function(gettext, _, S, $, Backbone, Backform, Backgrid, CodeMirror) {
+  'backbone', 'backform', 'backgrid', 'codemirror', 'sources/sqleditor_utils',
+  'spectrum', 'pgadmin.backgrid', 'select2',
+], function(gettext, _, S, $, Backbone, Backform, Backgrid, CodeMirror, SqlEditorUtils) {
 
-  var pgAdmin = (window.pgAdmin = window.pgAdmin || {});
+  var pgAdmin = (window.pgAdmin = window.pgAdmin || {}),
+    pgBrowser = pgAdmin.Browser;
 
   pgAdmin.editableCell = function() {
     if (this.attributes && !_.isUndefined(this.attributes.disabled) &&
@@ -1259,8 +1260,7 @@ define([
       var subnode = data.subnode.schema ? data.subnode : data.subnode.prototype,
         gridSchema = Backform.generateGridColumnsFromModel(
           data.node_info, subnode, this.field.get('mode'), data.columns, data.schema_node
-        ),
-        pgBrowser = window.pgAdmin.Browser;
+        );
 
       // Clean up existing grid if any (in case of re-render)
       if (self.grid) {
@@ -1428,6 +1428,23 @@ define([
     getValueFromDOM: function() {
       return this.formatter.toRaw(this.$el.find('textarea').val(), this.model);
     },
+
+    reflectPreferences: function() {
+      var self = this;
+      /* self.sqlCtrl is null when SQL tab is not active */
+      if(self.sqlCtrl) {
+        let sqlEditPreferences = pgAdmin.Browser.get_preferences_for_module('sqleditor');
+
+        $(self.sqlCtrl.getWrapperElement()).css(
+          'font-size',SqlEditorUtils.calcFontSize(sqlEditPreferences.sql_font_size)
+        );
+        self.sqlCtrl.setOption('tabSize', sqlEditPreferences.tab_size);
+        self.sqlCtrl.setOption('lineWrapping', sqlEditPreferences.wrap_code);
+        self.sqlCtrl.setOption('autoCloseBrackets', sqlEditPreferences.insert_pair_brackets);
+        self.sqlCtrl.setOption('matchBrackets', sqlEditPreferences.brace_matching);
+        self.sqlCtrl.refresh();
+      }
+    },
     render: function() {
       if (this.sqlCtrl) {
         this.sqlCtrl.toTextArea();
@@ -1446,12 +1463,16 @@ define([
           mode: 'text/x-pgsql',
           readOnly: true,
           extraKeys: pgAdmin.Browser.editor_shortcut_keys,
-          tabSize: pgAdmin.Browser.editor_options.tabSize,
-          lineWrapping: pgAdmin.Browser.editor_options.wrapCode,
-          autoCloseBrackets: pgAdmin.Browser.editor_options.insert_pair_brackets,
-          matchBrackets: pgAdmin.Browser.editor_options.brace_matching,
         });
 
+      this.reflectPreferences();
+
+      /* Check for sql editor preference changes */
+      let self = this;
+      pgBrowser.onPreferencesChange('sqleditor', function() {
+        self.reflectPreferences();
+      });
+
       /*
        * We will listen to the tab change event to check, if the SQL tab has
        * been clicked or, not.
@@ -1571,7 +1592,6 @@ define([
   ) {
     var proto = (Model && Model.prototype) || Model,
       schema = subschema || (proto && proto.schema),
-      pgBrowser = window.pgAdmin.Browser,
       fields = [],
       groupInfo = {};
 
@@ -2051,6 +2071,25 @@ define([
       return this.sqlCtrl.getValue();
     },
 
+    reflectPreferences: function() {
+      var self = this;
+      /* self.sqlCtrl is null when Definition tab is not active */
+      if(self.sqlCtrl) {
+        let sqlEditPreferences = pgAdmin.Browser.get_preferences_for_module('sqleditor');
+
+        $(self.sqlCtrl.getWrapperElement()).css(
+          'font-size',SqlEditorUtils.calcFontSize(sqlEditPreferences.sql_font_size)
+        );
+        self.sqlCtrl.setOption('indentWithTabs', !sqlEditPreferences.use_spaces);
+        self.sqlCtrl.setOption('indentUnit', sqlEditPreferences.tab_size);
+        self.sqlCtrl.setOption('tabSize', sqlEditPreferences.tab_size);
+        self.sqlCtrl.setOption('lineWrapping', sqlEditPreferences.wrap_code);
+        self.sqlCtrl.setOption('autoCloseBrackets', sqlEditPreferences.insert_pair_brackets);
+        self.sqlCtrl.setOption('matchBrackets', sqlEditPreferences.brace_matching);
+        self.sqlCtrl.refresh();
+      }
+    },
+
     render: function() {
       // Clean up the existing sql control
       if (this.sqlCtrl) {
@@ -2093,14 +2132,14 @@ define([
           lineNumbers: true,
           mode: 'text/x-pgsql',
           extraKeys: pgAdmin.Browser.editor_shortcut_keys,
-          indentWithTabs: pgAdmin.Browser.editor_options.indent_with_tabs,
-          indentUnit: pgAdmin.Browser.editor_options.tabSize,
-          tabSize: pgAdmin.Browser.editor_options.tabSize,
-          lineWrapping: pgAdmin.Browser.editor_options.wrapCode,
-          autoCloseBrackets: pgAdmin.Browser.editor_options.insert_pair_brackets,
-          matchBrackets: pgAdmin.Browser.editor_options.brace_matching,
         });
 
+      self.reflectPreferences();
+      /* Check for sql editor preference changes */
+      pgBrowser.onPreferencesChange('sqleditor', function() {
+        self.reflectPreferences();
+      });
+
       // Disable editor
       if (isDisabled) {
         // set read only mode to true instead of 'nocursor', and hide cursor using a class so that copying is enabled
diff --git a/web/pgadmin/static/js/keyboard_shortcuts.js b/web/pgadmin/static/js/keyboard_shortcuts.js
index 1fe07e9b..57d8a303 100644
--- a/web/pgadmin/static/js/keyboard_shortcuts.js
+++ b/web/pgadmin/static/js/keyboard_shortcuts.js
@@ -8,6 +8,7 @@
 //////////////////////////////////////////////////////////////////////////
 
 import $ from 'jquery';
+import gettext from 'sources/gettext';
 
 const PERIOD_KEY = 190,
   FWD_SLASH_KEY = 191,
@@ -49,6 +50,52 @@ function isCtrlAltBoth(event) {
   return event.ctrlKey && event.altKey && !event.shiftKey;
 }
 
+/* Returns the key of shortcut */
+function shortcut_key(shortcut) {
+  let key = '';
+  if(shortcut['key'] && shortcut['key']['char']) {
+    key = shortcut['key']['char'].toUpperCase();
+  }
+  return key;
+}
+
+/* Converts shortcut object to title representation
+ * Shortcut object is browser.get_preference().value
+ */
+function shortcut_title(title, shortcut) {
+  let text_representation = '';
+
+  if (typeof shortcut === 'undefined' || shortcut === null) {
+    return text_representation;
+  }
+  if(shortcut['alt']) {
+    text_representation = gettext('Alt') + '+';
+  }
+  if(shortcut['shift']) {
+    text_representation += gettext('Shift') + '+';
+  }
+  if(shortcut['control']) {
+    text_representation += gettext('Ctrl') + '+';
+  }
+  text_representation += shortcut_key(shortcut);
+
+  return gettext('%(title)s (%(text_representation)s)',{
+    'title': title,
+    'text_representation': text_representation,
+  });
+}
+
+/* Returns the key char of shortcut
+ * shortcut object is browser.get_preference().value
+ */
+function shortcut_accesskey_title(title, shortcut) {
+  return gettext('%(title)s (accesskey + %(key)s)',{
+    'title': title,
+    'key': shortcut_key(shortcut),
+  });
+}
+
+
 function _stopEventPropagation(event) {
   event.cancelBubble = true;
   event.preventDefault();
@@ -124,19 +171,19 @@ function getInnerPanel($el, direction) {
 
 /* Query tool: Keyboard Shortcuts handling */
 function keyboardShortcutsQueryTool(
-  sqlEditorController, keyboardShortcutConfig, queryToolActions, event
+  sqlEditorController, queryToolActions, event
 ) {
   if (sqlEditorController.isQueryRunning()) {
     return;
   }
   let keyCode = event.which || event.keyCode, panel_id;
-  let executeKeys = keyboardShortcutConfig['execute'];
-  let explainKeys = keyboardShortcutConfig['explain'];
-  let explainAnalyzeKeys = keyboardShortcutConfig['explain_analyze'];
-  let downloadCsvKeys = keyboardShortcutConfig['download_csv'];
-  let nextPanelKeys = keyboardShortcutConfig['move_next'];
-  let previousPanelKeys = keyboardShortcutConfig['move_previous'];
-  let toggleCaseKeys = keyboardShortcutConfig['toggle_case'];
+  let executeKeys = sqlEditorController.preferences.execute_query;
+  let explainKeys = sqlEditorController.preferences.explain_query;
+  let explainAnalyzeKeys = sqlEditorController.preferences.explain_analyze_query;
+  let downloadCsvKeys = sqlEditorController.preferences.download_csv;
+  let nextPanelKeys = sqlEditorController.preferences.move_next;
+  let previousPanelKeys = sqlEditorController.preferences.move_previous;
+  let toggleCaseKeys = sqlEditorController.preferences.toggle_case;
 
   if (this.validateShortcutKeys(executeKeys, event)) {
     this._stopEventPropagation(event);
@@ -245,4 +292,7 @@ module.exports = {
   isAltShiftBoth: isAltShiftBoth,
   isCtrlShiftBoth: isCtrlShiftBoth,
   isCtrlAltBoth: isCtrlAltBoth,
+  shortcut_key : shortcut_key,
+  shortcut_title : shortcut_title,
+  shortcut_accesskey_title : shortcut_accesskey_title,
 };
diff --git a/web/pgadmin/static/js/sqleditor/query_tool_actions.js b/web/pgadmin/static/js/sqleditor/query_tool_actions.js
index 411c6ed5..6cbbce0f 100644
--- a/web/pgadmin/static/js/sqleditor/query_tool_actions.js
+++ b/web/pgadmin/static/js/sqleditor/query_tool_actions.js
@@ -119,58 +119,6 @@ let queryToolActions = {
     window.top.document.activeElement.blur();
   },
 
-  getKeyboardShortcuts: function (sqlEditorController) {
-    let executeQueryPref = window.top.pgAdmin.Browser.get_preference(
-      'sqleditor', 'execute_query');
-    let explainQueryPref = window.top.pgAdmin.Browser.get_preference(
-      'sqleditor', 'explain_query');
-    let explainAnalyzeQueryPref = window.top.pgAdmin.Browser.get_preference(
-      'sqleditor', 'explain_analyze_query');
-    let downloadCsvPref = window.top.pgAdmin.Browser.get_preference(
-      'sqleditor', 'download_csv');
-    let nextPanelPerf = window.top.pgAdmin.Browser.get_preference(
-      'sqleditor', 'move_next');
-    let previousPanelPerf = window.top.pgAdmin.Browser.get_preference(
-      'sqleditor', 'move_previous');
-    let toggleCasePerf = window.top.pgAdmin.Browser.get_preference(
-      'sqleditor', 'toggle_case');
-
-    if(!executeQueryPref && sqlEditorController.handler.is_new_browser_tab) {
-      executeQueryPref = window.opener.pgAdmin.Browser.get_preference(
-        'sqleditor', 'execute_query'
-      ),
-      explainQueryPref = window.opener.pgAdmin.Browser.get_preference(
-        'sqleditor', 'explain_query'
-      ),
-      explainAnalyzeQueryPref = window.opener.pgAdmin.Browser.get_preference(
-        'sqleditor', 'explain_analyze_query'
-      ),
-      downloadCsvPref = window.opener.pgAdmin.Browser.get_preference(
-        'sqleditor', 'download_csv'
-      ),
-      nextPanelPerf = window.opener.pgAdmin.Browser.get_preference(
-        'sqleditor', 'move_next'
-      ),
-      previousPanelPerf = window.opener.pgAdmin.Browser.get_preference(
-        'sqleditor', 'move_previous'
-      ),
-      toggleCasePerf = window.opener.pgAdmin.Browser.get_preference(
-        'sqleditor', 'toggle_case'
-      );
-    }
-
-    return {
-      'execute': executeQueryPref.value,
-      'explain': explainQueryPref.value,
-      'explain_analyze': explainAnalyzeQueryPref.value,
-      'download_csv': downloadCsvPref.value,
-      'move_next': nextPanelPerf.value,
-      'move_previous': previousPanelPerf.value,
-      'toggle_case': toggleCasePerf.value,
-    };
-
-  },
-
   toggleCaseOfSelectedText: function (sqlEditorController) {
     let codeMirrorObj = sqlEditorController.gridView.query_tool_obj;
     let selectedText = codeMirrorObj.getSelection();
diff --git a/web/pgadmin/static/js/sqleditor/query_tool_preferences.js b/web/pgadmin/static/js/sqleditor/query_tool_preferences.js
new file mode 100644
index 00000000..3ee2f0bc
--- /dev/null
+++ b/web/pgadmin/static/js/sqleditor/query_tool_preferences.js
@@ -0,0 +1,179 @@
+import {shortcut_key, shortcut_accesskey_title, shortcut_title}
+  from 'sources/keyboard_shortcuts';
+import * as SqlEditorUtils from 'sources/sqleditor_utils';
+import $ from 'jquery';
+
+function reflectPreferences(sqlEditor) {
+  let $el = sqlEditor.$el,
+    preferences = sqlEditor.preferences;
+
+  if(sqlEditor.handler.slickgrid) {
+    sqlEditor.handler.slickgrid.CSVOptions = {
+      quoting: sqlEditor.preferences.results_grid_quoting,
+      quote_char: sqlEditor.preferences.results_grid_quote_char,
+      field_separator: sqlEditor.preferences.results_grid_field_separator,
+    };
+  }
+
+  /* Accessed using accesskey direct w/o ctrl,atl,shift */
+  $el.find('#btn-load-file')
+    .attr('title', shortcut_accesskey_title('Open File',preferences.btn_open_file))
+    .attr('accesskey', shortcut_key(preferences.btn_open_file));
+
+  $el.find('#btn-save')
+    .attr('title', shortcut_accesskey_title('Save File',preferences.btn_save_file))
+    .attr('accesskey', shortcut_key(preferences.btn_save_file));
+
+  $el.find('#btn-find-menu-dropdown')
+    .attr('title', shortcut_accesskey_title('Find',preferences.btn_find_options))
+    .attr('accesskey', shortcut_key(preferences.btn_find_options));
+
+  $el.find('#btn-copy-row')
+    .attr('title', shortcut_accesskey_title('Copy',preferences.btn_copy_row))
+    .attr('accesskey', shortcut_key(preferences.btn_copy_row));
+
+  $el.find('#btn-paste-row')
+    .attr('title', shortcut_accesskey_title('Paste',preferences.btn_paste_row))
+    .attr('accesskey', shortcut_key(preferences.btn_paste_row));
+
+  $el.find('#btn-delete-row')
+    .attr('title', shortcut_accesskey_title('Delete',preferences.btn_delete_row))
+    .attr('accesskey', shortcut_key(preferences.btn_delete_row));
+
+  $el.find('#btn-filter')
+    .attr('title', shortcut_accesskey_title('Filter',preferences.btn_filter_dialog))
+    .attr('accesskey', shortcut_key(preferences.btn_filter_dialog));
+
+  $el.find('#btn-filter-dropdown')
+    .attr('title', shortcut_accesskey_title('Filter options',preferences.btn_filter_options))
+    .attr('accesskey', shortcut_key(preferences.btn_filter_options));
+
+  $el.find('#btn-rows-limit')
+    .attr('title', shortcut_accesskey_title('Rows limit',preferences.btn_rows_limit))
+    .attr('accesskey', shortcut_key(preferences.btn_rows_limit));
+
+  $el.find('#btn-query-dropdown')
+    .attr('title', shortcut_accesskey_title('Execute options',preferences.btn_execute_options))
+    .attr('accesskey', shortcut_key(preferences.btn_execute_options));
+
+  $el.find('#btn-cancel-query')
+    .attr('title', shortcut_accesskey_title('Cancel query',preferences.btn_cancel_query))
+    .attr('accesskey', shortcut_key(preferences.btn_cancel_query));
+
+  $el.find('#btn-clear-dropdown')
+    .attr('title', shortcut_accesskey_title('Clear',preferences.btn_clear_options))
+    .attr('accesskey', shortcut_key(preferences.btn_clear_options));
+
+  $el.find('#btn-conn-status')
+    .attr('accesskey', shortcut_key(preferences.btn_conn_status))
+    .find('i')
+    .attr('title',
+      shortcut_accesskey_title('Connection status (click for details)',
+                            preferences.btn_conn_status));
+
+  /* Accessed using ctrl,atl,shift and key */
+  $el.find('#btn-flash')
+    .attr('title',
+      shortcut_title('Execute/Refresh',preferences.execute_query));
+
+  $el.find('#btn-flash-menu span')
+    .text(shortcut_title('Execute/Refresh',preferences.execute_query));
+
+  $el.find('#btn-explain span')
+    .text(shortcut_title('Explain',preferences.explain_query));
+
+  $el.find('#btn-explain-analyze span')
+    .text(shortcut_title('Explain Analyze',preferences.explain_analyze_query));
+
+  $el.find('#btn-download')
+    .attr('title',
+      shortcut_title('Download as CSV',preferences.download_csv));
+
+  /* Set Auto-commit and auto-rollback on query editor */
+  if (preferences.auto_commit) {
+    $el.find('.auto-commit').removeClass('visibility-hidden');
+  }
+  else {
+    $el.find('.auto-commit').addClass('visibility-hidden');
+  }
+  if (preferences.auto_rollback) {
+    $el.find('.auto-rollback').removeClass('visibility-hidden');
+  }
+  else {
+    $el.find('.auto-rollback').addClass('visibility-hidden');
+  }
+
+  /* Set explain options on query editor */
+  if (preferences.explain_verbose){
+    $el.find('.explain-verbose').removeClass('visibility-hidden');
+  }
+  else {
+    $el.find('.explain-verbose').addClass('visibility-hidden');
+  }
+
+  if (preferences.explain_costs){
+    $el.find('.explain-costs').removeClass('visibility-hidden');
+  }
+  else {
+    $el.find('.explain-costs').addClass('visibility-hidden');
+  }
+
+  if (preferences.explain_buffers){
+    $el.find('.explain-buffers').removeClass('visibility-hidden');
+  }
+  else {
+    $el.find('.explain-buffers').addClass('visibility-hidden');
+  }
+
+  if (preferences.explain_timing) {
+    $el.find('.explain-timing').removeClass('visibility-hidden');
+  }
+  else {
+    $el.find('.explain-timing').addClass('visibility-hidden');
+  }
+
+  /* Connection status check */
+  /* remove the status checker if present */
+  if(sqlEditor.connIntervalId != null) {
+    clearInterval(sqlEditor.connIntervalId);
+    sqlEditor.connIntervalId = null;
+  }
+  if (preferences.connection_status) {
+    let $conn_status = $el.find('#btn-conn-status'),
+      $status_el = $conn_status.find('i');
+    $conn_status.popover();
+
+    $conn_status.removeClass('connection-status-hide');
+    $el.find('.editor-title').addClass('editor-title-connection');
+
+    // To set initial connection
+    SqlEditorUtils.fetchConnectionStatus(sqlEditor.handler, $conn_status, $status_el);
+
+    // Calling it again in specified interval
+    sqlEditor.connIntervalId =  setInterval(
+        SqlEditorUtils.fetchConnectionStatus.bind(null, sqlEditor.handler, $conn_status, $status_el),
+        preferences.connection_status_fetch_time * 1000
+    );
+  }
+  else {
+    $el.find('#btn-conn-status').addClass('connection-status-hide');
+    $el.find('.editor-title').removeClass('editor-title-connection');
+  }
+
+  /* Code Mirror Preferences */
+  let sql_font_size = SqlEditorUtils.calcFontSize(preferences.sql_font_size);
+  $(sqlEditor.query_tool_obj.getWrapperElement()).css('font-size', sql_font_size);
+
+  sqlEditor.query_tool_obj.setOption('indentWithTabs', !preferences.use_spaces);
+  sqlEditor.query_tool_obj.setOption('indentUnit', preferences.tab_size);
+  sqlEditor.query_tool_obj.setOption('tabSize', preferences.tab_size);
+  sqlEditor.query_tool_obj.setOption('lineWrapping', preferences.wrap_code);
+  sqlEditor.query_tool_obj.setOption('autoCloseBrackets', preferences.insert_pair_brackets);
+  sqlEditor.query_tool_obj.setOption('matchBrackets', preferences.brace_matching);
+  sqlEditor.query_tool_obj.refresh();
+
+  /* Render history to reflect Font size change */
+  sqlEditor.render_history_grid();
+}
+
+export {reflectPreferences};
diff --git a/web/pgadmin/static/js/sqleditor_utils.js b/web/pgadmin/static/js/sqleditor_utils.js
index be41566f..0fff1d95 100644
--- a/web/pgadmin/static/js/sqleditor_utils.js
+++ b/web/pgadmin/static/js/sqleditor_utils.js
@@ -178,24 +178,6 @@ define(['jquery', 'sources/gettext', 'sources/url_for'],
         });
       },
 
-      // This function will update the connection status
-      updateConnectionStatus: function(target, poll_time) {
-        var $el = $(target.gridView.$el.find('.connection_status')),
-          $status_el = $($el.find('.fa-custom'));
-
-        // Apply popover on element
-        $el.popover();
-
-        // To set initial connection statussource$el.popover()
-        sqlEditorUtils.fetchConnectionStatus(target, $el, $status_el);
-
-        // Calling it again in specified interval
-        setInterval(
-          sqlEditorUtils.fetchConnectionStatus.bind(null, target, $el, $status_el),
-          poll_time * 1000
-        );
-      },
-
       // Updates the flag for connection status poll
       updateConnectionStatusFlag: function(status) {
         var $el = $('.connection_status');
@@ -203,6 +185,15 @@ define(['jquery', 'sources/gettext', 'sources/url_for'],
           $el.data('panel-visible', status);
         }
       },
+
+      calcFontSize: function(fontSize) {
+        if(fontSize) {
+          return Number((Math.round(fontSize + 'e+2') + 'e-2')) + 'em';
+        }
+        else {
+          return '0em';
+        }
+      },
     };
     return sqlEditorUtils;
   });
diff --git a/web/pgadmin/static/jsx/history/detail/code_mirror.jsx b/web/pgadmin/static/jsx/history/detail/code_mirror.jsx
index 6e982128..038cc200 100644
--- a/web/pgadmin/static/jsx/history/detail/code_mirror.jsx
+++ b/web/pgadmin/static/jsx/history/detail/code_mirror.jsx
@@ -50,6 +50,11 @@ export default class CodeMirror extends React.Component {
     Object.keys(props.options || {}).forEach(key => this.editor.setOption(key, props.options[key]));
 
     this.editor.setValue(props.value || '');
+
+    if(props.sqlFontSize) {
+      $(this.editor.getWrapperElement()).css('font-size', props.sqlFontSize);
+    }
+
     this.editor.refresh();
   }
 
